/////////////////////////////////////////////////////////////////
// RESTART.C - 1993, Jeffrey M. Perkel
// RESTART is a utility that allows the user to quit or restart
// Windows.
/////////////////////////////////////////////////////////////////


#include <windows.h>
#include <string.h>
#include "restart.h"
                    
static HINSTANCE ghInstance;
static char szAppName[] = "Restart";

BOOL FAR PASCAL _export MainDlgProc (HWND hDlg, unsigned message, WORD
        wParam, LONG lParam);
BOOL MakeItSo (int Action);
BOOL AreYouSure (HWND hDlg, int Action);

int PASCAL WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
        LPSTR lpCmdLine, int nCmdShow)
        {
        ghInstance = hInstance;
        
        if (!hPrevInstance)
                {
                WNDCLASS wndclass;
                
                wndclass.style = CS_HREDRAW | CS_VREDRAW;
                wndclass.lpfnWndProc = DefDlgProc;
                wndclass.cbClsExtra = 0;
                wndclass.cbWndExtra = DLGWINDOWEXTRA;
                wndclass.hInstance = ghInstance;
                wndclass.hIcon = LoadIcon (NULL, IDI_APPLICATION);
                wndclass.hCursor = LoadCursor (NULL, IDC_ARROW);
                wndclass.hbrBackground = GetStockObject (WHITE_BRUSH);
                wndclass.lpszMenuName = NULL;
                wndclass.lpszClassName = szAppName;                
        
                if (!RegisterClass (&wndclass)) return FALSE;
                }
                
        return DialogBoxParam (ghInstance, szAppName, NULL, (DLGPROC)
                MakeProcInstance ((FARPROC) MainDlgProc, ghInstance),
                (LONG) nCmdShow);
}
                
BOOL FAR PASCAL _export MainDlgProc (HWND hDlg, unsigned message, WORD
        wParam, LONG lParam)
        {
        switch (message)
                {
                case WM_INITDIALOG:
                        ShowWindow (hDlg, LOWORD(lParam));
                        break;
                case WM_CLOSE:
                        EndDialog (hDlg, FALSE);
                        break;
                case WM_COMMAND:
                        switch (wParam)
                                {
                                case ID_OK:
                                {
                                int Action;
                                BOOL bSuccess, bAnswer;
                                
                                Action = (IsDlgButtonChecked (hDlg,
                                IDD_RESTART)) ? EW_RESTARTWINDOWS : 
                                (IsDlgButtonChecked (hDlg, IDD_EXIT)) ? 
                                NULL : NOCHECK;
                                if (Action == NOCHECK) 
                                        {
                                        MessageBeep(0);
                                        break;
                                        }
                                bAnswer = AreYouSure (hDlg, Action);
                                if (!bAnswer) break;
                                bSuccess = MakeItSo (Action);
                                if (!bSuccess) {
                                        MessageBox (hDlg, "One or more  \
                                        applicatons refused to          \
                                        terminate!", szAppName, MB_OK);
                                        }
                                break;
                                }
                                case ID_CANCEL:
                                        EndDialog (hDlg, FALSE);
                                        break;
                                }        
                                default:
                                        return FALSE;
                                }
                        return TRUE;
                        }
            
                  
/////////////////////////////////////////////////////////////
// MakeItSo - This function is the "meat" of the program.
/////////////////////////////////////////////////////////////                                        
BOOL MakeItSo (int Action)
{
        BOOL bResult;
            
        bResult = ExitWindows (Action, 0);
        return bResult;
}                                                  

/////////////////////////////////////////////////////////////
// AreYouSure - Confirm the user's response.
/////////////////////////////////////////////////////////////

BOOL AreYouSure (HWND hDlg, int Action)
{
        char szBuffer[18];
        short nAnswer;
        
        wsprintf (szBuffer, "%s Windows?", (LPSTR) (Action == 
        EW_RESTARTWINDOWS ? "Restart" : "Exit"));
        nAnswer = MessageBox (hDlg, szBuffer, "Confirm", MB_YESNOCANCEL | 
        MB_ICONQUESTION);
        
        if ((nAnswer == IDNO) || (nAnswer == IDCANCEL)) return FALSE;
        else return TRUE;
}
